#include <stdio.h>
#include <stdlib.h>

#define MAXN 1000000

struct structXY {
  int x, y;
  int used;
};

structXY T[MAXN];
int hi[MAXN];
int lo[MAXN];

int cmp (void const * a, void const * b) {
  int ax = ((structXY const *)a)->x;
  int bx = ((structXY const *)b)->x;
  if (ax < bx) return -1;
  if (ax > bx) return +1;
  int ay = ((structXY const *)a)->y;
  int by = ((structXY const *)b)->y;
  if (ay < by) return -1;
  if (ay > by) return +1;
  return 0;
};

typedef long long LL;

LL CCW (int x0, int y0, int x1, int y1, int x2, int y2) {
  return LL(x0 - x1) * LL(y2 - y1) - LL(x2 - x1) * LL(y0 - y1);
};

int main (void) {
  int d;
  scanf("%d", &d);
  while (d--) {
    int N;
    scanf("%d", &N);
    for (int i = 0; i < N; i++) {
      scanf("%d %d", &T[i].x, &T[i].y);
      T[i].used = 0;
    };
    qsort(T, N, sizeof(*T), cmp);
    for (int i = 1; i < N; i++) {
      if ((T[i].x == T[i - 1].x) && (T[i].y == T[i - 1].y)) {
        fprintf(stderr, "d:%d N:%d i:%d-%d duplicate point!\n", d, N, i - 1, i);
      };
    };
    
    int left = N;
    int layers = 0;
    while (left) {
//    printf("[layers: %d; left: %d]\n", layers, left);
      int hip = 0, lop = 0; //first free
      for (int i = 0; i < N; i++) if (!T[i].used) {
        left--;
	while (hip >= 2) {
	  int k = hi[hip - 2];
	  int j = hi[hip - 1];
	  if (CCW(T[k].x, T[k].y, T[j].x, T[j].y, T[i].x, T[i].y) >= 0) break;
	  hip--;
	  if (!--T[hi[hip]].used) left++;
	};
	hi[hip++] = i;
	T[i].used++;	
	while (lop >= 2) {
	  int k = lo[lop - 2];
	  int j = lo[lop - 1];
	  if (CCW(T[k].x, T[k].y, T[j].x, T[j].y, T[i].x, T[i].y) <= 0) break;
	  lop--;
	  if (!--T[lo[lop]].used) left++;
	};
	lo[lop++] = i;
	T[i].used++;
      };
      layers++;
    };
    
    printf("%d\n", layers);
  };
  return 0;
};
